/******************************************************************************
|Project	|Windows9x/NT/2000 ScreenServer skelton project
|Copyright	|Copyright(C)1997-1999,2000 Scope,Kazuhiko Watanabe
|			|mailto:scope@mx5.et.tiki.ne.jp
|			|http://ww5.et.tiki.ne.jp/~scope/
|-----------+---------------+--------------------------------------------------
|content	|[eBeB[
|			|Microsoft Visual C/C++6.0
|			|necessary "SCRNSAVE.LIB" with "WINMM.LIB" Liblary
|-----------+---------------+--------------------------------------------------
|Renewal	|1997/10/09		Kazuhiko Watanabe
|			|1999/05/24		Version up
|			|2000/05/20		W2K renew,MSVC6.0 convert
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
******************************************************************************/
#include	<windows.h>
#include	<scrnsave.h>
#include	<commctrl.h>
#include	<math.h>
//
#include	"resource.h"
#include	"main.h"
#include	"util.h"

/******************************************************************************
|	擾
|-------+-------------------+--------------------------------------------------
|Entry	|hWnd				޳
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_GetSysInfo(
	HWND			hWnd
){
	LPSSTATE		pState;
	TCHAR			szBuf[MAX_STR];
	HDC				hDC;
	SYSTEM_INFO		siSysInfo;
	MEMORYSTATUS	msMemStatus;
//	DWORD			dwSecPerClu,dwBytePerSec,dwNumOfFreeClu,dwTotalNumOfClu;
	BOOL			bRes;
	DWORD			dwTemp;
	int				iTemp;
	int				lp;

	// Ǘ擾
	pState = (PSSTATE)GetWindowLong(hWnd,GWL_USERDATA);
	// State : User Name
	dwTemp = MAX_STR;
	GetUserName(pState->siSysInfo.szUserName,&dwTemp);
	// State : Computer Name
	dwTemp = MAX_STR;
	GetComputerName(pState->siSysInfo.szComputerName,&dwTemp);
	// State : Current Directory
	GetCurrentDirectory(MAX_PATH,pState->siSysInfo.szCurrentDirPath);
	// State : Windows Directory
	GetWindowsDirectory(pState->siSysInfo.szWindowsDirPath,MAX_PATH);
	// State : Windows System Directory
	GetSystemDirectory(pState->siSysInfo.szSystemDirPath,MAX_PATH);
	// State : OS Version
	pState->siSysInfo.ovOSVersion.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&pState->siSysInfo.ovOSVersion);
	// State : Video Device Capability
	hDC = GetDC(hWnd);
	pState->siSysInfo.iScreenBPP = GetDeviceCaps(hDC,BITSPIXEL);
	ReleaseDC(hWnd,hDC);
	pState->siSysInfo.iScreenWidth = GetSystemMetrics(SM_CXSCREEN);
	pState->siSysInfo.iScreenHeight = GetSystemMetrics(SM_CYSCREEN);
	// State : Drive Type
	dwTemp = GetLogicalDrives();
	for(lp = 0;lp < MAX_DRIVE;lp++) {
		pState->siSysInfo.diDrive[lp].iDriveType = 0;
		if (dwTemp & 0x01) {
			wsprintf(szBuf,"%c:\\",(BYTE)('A' + lp));
			iTemp = GetDriveType(szBuf); 
			switch(iTemp) {
				case DRIVE_REMOVABLE:
				case DRIVE_FIXED:
				case DRIVE_CDROM:
				case DRIVE_REMOTE:
				case DRIVE_RAMDISK:
					pState->siSysInfo.diDrive[lp].iDriveType = iTemp;
					break;
			}
/*
			GetDiskFreeSpace(szBuf,&dwSecPerClu,&dwBytePerSec,&dwNumOfFreeClu,&dwTotalNumOfClu);
			bRes = GetVolumeInformation(szBuf,
				pState->siSysInfo.diDrive[lp].szVolLabel,MAX_STR - 1,
				NULL,&dwTemp,NULL,
				pState->siSysInfo.diDrive[lp].szFileSysName,MAX_STR - 1);
			if (bRes == TRUE) {
				pState->siSysInfo.diDrive[lp].bLongFileName = FALSE;
				if (dwTemp == 255) {
					pState->siSysInfo.diDrive[lp].bLongFileName = TRUE;
				}
				pState->siSysInfo.diDrive[lp].dwDiskSpace =
					dwBytePerSec * dwSecPerClu * dwTotalNumOfClu;
				pState->siSysInfo.diDrive[lp].dwDiskFreeSpace =
					dwBytePerSec * dwSecPerClu * dwNumOfFreeClu;
			}
*/
		}
		dwTemp >>= 1;
	}
	// State : System Metrics
	pState->siSysInfo.bPresentMouse = FALSE;
	if (GetSystemMetrics(SM_MOUSEPRESENT) != 0) {
		pState->siSysInfo.bPresentMouse = TRUE;
	}
	// State : System Infomation
	GetSystemInfo(&siSysInfo);
	pState->siSysInfo.dwProcessorType = siSysInfo.dwProcessorType;
	// State : Memory Infomation
	msMemStatus.dwLength = sizeof(MEMORYSTATUS);
	GlobalMemoryStatus(&msMemStatus);
	pState->siSysInfo.dwTotalMemSize = msMemStatus.dwTotalPhys;
	pState->siSysInfo.dwMemSize = msMemStatus.dwAvailPhys;
	pState->siSysInfo.dwTotalVirtualMemSize = msMemStatus.dwTotalVirtual;
	pState->siSysInfo.dwVirtualMemSize = msMemStatus.dwAvailVirtual;
	// State : Power Status
	pState->siSysInfo.bPowerStatus = FALSE;
	bRes = GetSystemPowerStatus(&pState->siSysInfo.psPowerStatus);
	if (bRes == TRUE) {
		pState->siSysInfo.bPowerStatus = TRUE;
	}
	// State : Time
	GetLocalTime(&pState->siSysInfo.stLocalTime);
	GetSystemTime(&pState->siSysInfo.stSystemTime);

	return(TRUE);
}

/******************************************************************************
|	BMP̧قޯϯق̐
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				ϊΏ޲÷
|		|lpctstrFile		̧߽
|		|phBmp				擾ޯϯ
|Return	|BOOL				ߒl
|Memo	|LoadImage()95/NTۏ؂̂߂̊֐
|		|ޯϯ߂͍폜KvL
******************************************************************************/
BOOL util_CreateBitmapOfFile(
	HDC				hDC,
	LPCTSTR			lpctstrFile,
	HBITMAP			*phBmp
){
	HANDLE			hFile;
	BITMAPFILEHEADER	bfHead;
	BITMAPINFOHEADER	biHead;
	DWORD			dwReadByte;
	HGLOBAL			hBmpMem;
	DWORD			dwMemSize;
	HBITMAP			hBitmap;
	LPBITMAPINFO	pbiInfo;
	BOOL			bRes;

	// 
	hBitmap = NULL;
	hBmpMem = NULL;
	pbiInfo = NULL;
	hFile = INVALID_HANDLE_VALUE;
	// ̧ٵ
	hFile = CreateFile(lpctstrFile,GENERIC_READ,0,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		// ̧ٓǂݍ
		bRes = ReadFile(hFile,&bfHead,sizeof(BITMAPFILEHEADER),
			&dwReadByte,NULL);
		if (bRes == TRUE) {
			bRes = ReadFile(hFile,&biHead,sizeof(BITMAPINFOHEADER),
				&dwReadByte,NULL);
			if (bRes == TRUE) {
				dwMemSize = sizeof(BITMAPINFOHEADER);
				if (biHead.biBitCount <= 8) {
					dwMemSize += sizeof(RGBQUAD) * (1 << biHead.biBitCount);
				}
				pbiInfo = (LPBITMAPINFO)GlobalAlloc(GPTR,dwMemSize);
				if (pbiInfo != NULL) {
					pbiInfo->bmiHeader = biHead;
					if (biHead.biBitCount <= 8) {
						bRes = ReadFile(hFile,&pbiInfo->bmiColors,
							sizeof(RGBQUAD) * (1 << biHead.biBitCount),
							&dwReadByte,NULL);
					}
					SetFilePointer(hFile,bfHead.bfOffBits,NULL,FILE_BEGIN);
					dwMemSize = biHead.biSizeImage;
					if (dwMemSize == 0) {
						dwMemSize = (((biHead.biBitCount *
							biHead.biWidth) / 32) + 1) * biHead.biHeight;
					}
					hBmpMem = GlobalAlloc(GPTR,dwMemSize);
					if (hBmpMem != NULL) {
						bRes = ReadFile(hFile,hBmpMem,dwMemSize,
							&dwReadByte,NULL);
						// ޯϯߍ쐬
						hBitmap = CreateDIBitmap(hDC,&biHead,CBM_INIT,
							hBmpMem,pbiInfo,DIB_RGB_COLORS);
					}
				}
			}
		}
	}
	// J
	if (hBmpMem != NULL) {
		GlobalFree(hBmpMem);
	}
	if (pbiInfo != NULL) {
		GlobalFree(pbiInfo);
	}
	if (hFile != INVALID_HANDLE_VALUE) {
		CloseHandle(hFile);
	}
	if (phBmp != NULL) {
		*phBmp = hBitmap;
	}
	if (hBitmap == NULL) {
		return(FALSE);
	}

	return(TRUE);
}

/******************************************************************************
|	ؿޯϯ߂𒼐ڕ`
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				Ώ޲÷
|		|hInst				ݽݽ
|		|iResID				ؿID
|		|prcRc				]W(NULLL)
|		|pdwRop				ROP(NULLL)
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_DrawResBitmap(
	HDC				hDC,
	HINSTANCE		hInst,
	UINT			iResID,
	LPRECT			prcRc,
	LPDWORD			pdwRop
){
	HDC				hMemDC;
	HBITMAP			hBmp;
	HBITMAP			hBmpOld;
	BITMAP			bmBmp;
	RECT			rcRc;
	DWORD			dwRop;

	// `
	dwRop = SRCCOPY;
	if (pdwRop != NULL) {
		dwRop = *pdwRop;
	}
	hMemDC = CreateCompatibleDC(hDC);
	if (hMemDC != NULL) {
		hBmp = LoadBitmap(hInst,MAKEINTRESOURCE(iResID));
		if (hBmp != NULL) {
			GetObject(hBmp,sizeof(BITMAP),&bmBmp);
			rcRc.left = 0;
			rcRc.top = 0;
			rcRc.right = bmBmp.bmWidth;
			rcRc.bottom = bmBmp.bmHeight;
			if (prcRc != NULL) {
				rcRc = *prcRc;
			}
			hBmpOld = (HBITMAP)SelectObject(hMemDC,hBmp);
			StretchBlt(hDC,rcRc.left,rcRc.top,
				GetRectWidth(&rcRc),GetRectHeight(&rcRc),
				hMemDC,0,0,bmBmp.bmWidth,bmBmp.bmHeight,dwRop);
			SelectObject(hMemDC,hBmpOld);
			DeleteObject(hBmp);
		}
		DeleteDC(hMemDC);
		return(TRUE);
	}

	return(FALSE);
}

/******************************************************************************
|	ʕt`
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				޲÷
|		|lpctstrText		
|		|crText				F
|		|crBorder			F
|		|prcRc				``(NULLL)
|		|dwFlag				`׸
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_DrawText(
	HDC				hDC,
	LPCTSTR			lpctstrText,
	COLORREF		crText,
	COLORREF		crBorder,
	LPRECT			prcRc,
	DWORD			dwFlag
){
	INT				iBkModeOld;
	INT				iTextColorOld;
	INT				iX,iY;
	INT				iXtop,iYtop;
	INT				iXend,iYend;
	RECT			rcRc;
	RECT			rcText;
	UINT			iFormat;

	// 
	if (lpctstrText == NULL) {
		return(FALSE);
	}
	// 
	iBkModeOld = SetBkMode(hDC,TRANSPARENT);
	iTextColorOld = SetTextColor(hDC,RGB_BLACK);
	// vZ
	iFormat = 0;
	if (!(dwFlag & UTIL_DT_PLEFIX)) {
		iFormat |= DT_NOPREFIX;
	}
	if (!(dwFlag & UTIL_DT_MULTILINE)) {
		iFormat |= DT_VCENTER | DT_SINGLELINE;
	}
	switch(dwFlag & UTIL_DT_MASK_POS) {
		default:
		case UTIL_DT_LEFT:
			iFormat |= DT_LEFT;
			break;
		case UTIL_DT_RIGHT:
			iFormat |= DT_RIGHT;
			break;
		case UTIL_DT_CENTER:
			iFormat |= DT_CENTER;
			break;
	}
	switch(dwFlag & UTIL_DT_MASK_FACE) {
		default:
			iXtop = 1;
			iYtop = 1;
			iXend = 1;
			iYend = 1;
			break;
		case UTIL_DT_BORDER:
			iXtop = -1;
			iYtop = -1;
			iXend = 2;
			iYend = 2;
			break;
		case UTIL_DT_SHADOW:
			iXtop = 0;
			iYtop = 0;
			iXend = 2;
			iYend = 2;
			break;
		case UTIL_DT_SUNK:
			iXtop = -1;
			iYtop = -1;
			iXend = 1;
			iYend = 1;
			break;
		case UTIL_DT_BOLD:
			iXtop = 1;
			iYtop = 0;
			iXend = 2;
			iYend = 1;
			break;
	}
	// `
	SetRect(&rcText,0,0,0,0);
	if (prcRc == NULL) {
		DrawText(hDC,lpctstrText,lstrlen(lpctstrText),&rcText,DT_CALCRECT);
	}
	else {
		rcText = *prcRc;
	}
	SetTextColor(hDC,crBorder);
	for(iX = iXtop;iX < iXend;iX++) {
		for(iY = iYtop;iY < iYend;iY++) {
			rcRc = rcText;
			OffsetRect(&rcRc,iX,iY);
			DrawText(hDC,lpctstrText,lstrlen(lpctstrText),&rcRc,iFormat);
		}
	}
	rcRc = rcText;
	SetTextColor(hDC,crText);
	DrawText(hDC,lpctstrText,lstrlen(lpctstrText),&rcRc,iFormat);
	// I
	SetTextColor(hDC,iTextColorOld);
	SetBkMode(hDC,iBkModeOld);

	return(TRUE);
}

/******************************************************************************
|	ݕ`(w`ݸ)
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				޲÷
|		|hInst				ݽݽ
|		|lpctstrRes			ؿ
|		|iIconSize			ݻ
|		|prcRc				``(NULLL)
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_DrawIcon(
	HDC				hDC,
	HINSTANCE		hInst,
	LPCTSTR			lpctstrRes,
	int				iIconSize,
	LPRECT			prcRc
){
	HICON			hIcon;
	POINT			ptPt;

	// ۰
	hIcon = LoadIcon(hInst,lpctstrRes);
	if (hIcon == NULL) {
		return(FALSE);
	}
	// ݻޒ
	if (GetRectHeight(prcRc) < iIconSize) {
		iIconSize /= 2;
	}
	ptPt.x = (GetRectWidth(prcRc) - iIconSize) / 2;
	ptPt.y = (GetRectHeight(prcRc) - iIconSize) / 2;
	// ݕ`
	DrawIconEx(hDC,ptPt.x,ptPt.y,
		hIcon,iIconSize,iIconSize,0,NULL,DI_NORMAL);
	// ݊J
	DeleteObject(hIcon);

	return(TRUE);
}

/******************************************************************************
|	ޯϯق𑽎`
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				Ώ޲÷
|		|hBmp				ޯϯ
|		|prcRc				`Ώۋ`
|		|dwFlag				`׸
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_DrawBitmap(
	HDC				hDC,
	HBITMAP			hBmp,
	LPRECT			prcRc,
	DWORD			dwFlag
){
	HDC				hMemDC;
	HBITMAP			hBmpOld;
	BITMAP			bmBmp;
	POINT			ptPos;
	INT				lpx,lpy;

	// 
	if (hBmp == NULL) {
		return(FALSE);
	}
	// `
	hMemDC = CreateCompatibleDC(hDC);
	if (hMemDC != NULL) {
		GetObject(hBmp,sizeof(BITMAP),&bmBmp);
		hBmpOld = (HBITMAP)SelectObject(hMemDC,hBmp);
		switch(dwFlag) {
			case UTIL_DB_CENTER:
				ptPos.x = (GetRectWidth(prcRc) - bmBmp.bmWidth) / 2;
				ptPos.y = (GetRectHeight(prcRc) - bmBmp.bmHeight) / 2;
				BitBlt(hDC,ptPos.x,ptPos.y,bmBmp.bmWidth,bmBmp.bmHeight,
					hMemDC,0,0,SRCCOPY);
				break;
			case UTIL_DB_STRETCH:
				StretchBlt(hDC,prcRc->left,prcRc->top,
					GetRectWidth(prcRc),GetRectHeight(prcRc),
					hMemDC,0,0,bmBmp.bmWidth,bmBmp.bmHeight,SRCCOPY);
				break;
			case UTIL_DB_REPEAT:
				for(lpy = 0;lpy <
					GetRectHeight(prcRc) / bmBmp.bmHeight + 1;lpy++) {
					for(lpx = 0;lpx <
					GetRectWidth(prcRc) / bmBmp.bmWidth + 1;lpx++) {
					BitBlt(hDC,bmBmp.bmWidth * lpx,bmBmp.bmHeight * lpy,
						bmBmp.bmWidth,bmBmp.bmHeight,
						hMemDC,0,0,SRCCOPY);
					}
				}
				break;
		}
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		return(TRUE);
	}

	return(FALSE);
}

/******************************************************************************
|	ްݕ`
|-------+-------------------+--------------------------------------------------
|Entry	|hDC				޲÷
|		|prcRc				``
|		|crStart			JnF
|		|crEnd				IF
|		|dwFlag				׸()
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL util_DrawGradation(
	HDC				hDC,
	LPRECT			prcRc,
	COLORREF		crStart,
	COLORREF		crEnd,
	DWORD			dwFlag
){
	COLORREF		crColor;
	FLOAT			fBaseR;
	FLOAT			fBaseG;
	FLOAT			fBaseB;
	FLOAT			fRangeR;
	FLOAT			fRangeG;
	FLOAT			fRangeB;
	FLOAT			fRGB;
	INT				iRange;
	INT				iAccuracy;
	HBRUSH			hBrush;
	RECT			rcRc;
	INT				iStep;
	INT				lp;
	BOOL			bVertical;

	// 
	bVertical = FALSE;
	if (dwFlag == UTIL_GD_TOP || dwFlag == UTIL_GD_BOTTOM) {
		bVertical = TRUE;
	}
	iRange = GetRectWidth(prcRc);
	if (bVertical == TRUE) {
		iRange = GetRectHeight(prcRc);
	}
	iAccuracy = (iRange / 4) + 1;
	iStep = (iRange / iAccuracy) + 1;
	if (dwFlag == UTIL_GD_RIGHT || dwFlag == UTIL_GD_BOTTOM) {
		crColor = crStart;
		crStart = crEnd;
		crEnd = crColor;
	}
	SetRect(&rcRc,prcRc->left,prcRc->top,prcRc->left + iStep,prcRc->bottom);
	if (bVertical == TRUE) {
		SetRect(&rcRc,prcRc->left,prcRc->top,prcRc->right,prcRc->top + iStep);
	}
	fBaseR = (FLOAT)(GetRValue(crStart));
	fBaseG = (FLOAT)(GetGValue(crStart));
	fBaseB = (FLOAT)(GetBValue(crStart));
	fRangeR = (GetRValue(crEnd) - fBaseR) / (FLOAT)iAccuracy;
	fRangeG = (GetGValue(crEnd) - fBaseG) / (FLOAT)iAccuracy;
	fRangeB = (GetBValue(crEnd) - fBaseB) / (FLOAT)iAccuracy;
	// `
	for(lp = 0;lp < iAccuracy;lp++) {
		crColor = 0;
		fRGB = fBaseR + fRangeR * (FLOAT)lp;
		if (fRGB > 0) {
			crColor = (((UINT)fRGB) & 0xff);
		}
		fRGB = fBaseG + fRangeG * (FLOAT)lp;
		if (fRGB > 0) {
			crColor |= (((UINT)fRGB) & 0xff) << 8;
		}
		fRGB = fBaseB + fRangeB * (FLOAT)lp;
		if (fRGB > 0) {
			crColor |= (((UINT)fRGB) & 0xff) << 16;
		}
		hBrush = CreateSolidBrush(crColor);
		if (hBrush != NULL) {
			FillRect(hDC,&rcRc,hBrush);
			DeleteObject(hBrush);
		}
		if (dwFlag == UTIL_GD_TOP || dwFlag == UTIL_GD_BOTTOM) {
			OffsetRect(&rcRc,0,iStep);
		}
		else {
			OffsetRect(&rcRc,iStep,0);
		}
	}

	return(TRUE);
}




