/******************************************************************************
|Project	|Windows9x/NT/2000 ScreenServer skelton project
|Copyright	|Copyright(C)1997-1999,2000 Scope,Kazuhiko Watanabe
|			|mailto:scope@mx5.et.tiki.ne.jp
|			|http://ww5.et.tiki.ne.jp/~scope/
|-----------+---------------+--------------------------------------------------
|content	|XN[Z[o[{
|			|Microsoft Visual C/C++6.0
|			|necessary "SCRNSAVE.LIB" with "WINMM.LIB" Liblary
|-----------+---------------+--------------------------------------------------
|Renewal	|1997/10/09		Kazuhiko Watanabe
|			|1999/05/24		Version up
|			|2000/05/20		W2K renew,MSVC6.0 convert
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
|			|20--/--/--		-
******************************************************************************/
#include	<windows.h>
#include	<scrnsave.h>
#include	<math.h>
//
#include	"resource.h"
#include	"main.h"
#include	"ver.h"
#include	"util.h"

/*-----------------------------------------------------------------------------
	XN[Z[o[JXPgvWFNg
	Copyright(C)1997-1999,2000 Scope,Kazuhiko Watanabe

	
	ETCYłXN[Z[o[JłB
	EłɂقƂǂ̍g݂Ă܂B
	E֗ȕ`惉Cu[tĂ܂B

	XN[Z[o[̓́A{ɂ̃\[Xɂ̂݋LqĂB
	̃\[X͐GȂłB

	app_Init()		KvȏꍇAǉLqĂ
	app_Exit()		IKvȏꍇAǉLqĂ
	app_Paint()		ۂ̕`敔łButil.cpp𗘗pƊyłB

	ϐƂāASSTATE\̂ɂ܂Ƃ߂Ă܂B񂪕Kvȏꍇϐ̒ǉ
	́A𗘗pĂB(SĂ̊֐ɓnĂ̂ŕ֗ł)
	SSTATE\̂́Amain.hɒ`Ă܂B

	̕ۑ(SSTATE\̓)
	SSYSINFO		siSysInfo;		// ̏t
	SOPTION			soOption;		// ƎɎgp\(ҏW鎖)
	PSAPPINFO		papInfo;		// ƎɎgp\(ҏW鎖)

	soOption,papInfo͎RɕҏWĂB
	ꂼARtBOݒƓƎ̕ϐƂėpĂB

	
	EKtreadme.txtĂBgpȂǂLڂĂ܂B
	E𑜓xŒł͂܂BlĊJĂB(vr[܂)
	Eݒ_CAOꍇ́Aconfig.cppyу\[X̏CKvłB
	Es̕΁Az[y[W̌fŎ󂯕tĂ܂B
-----------------------------------------------------------------------------*/

/******************************************************************************
|	
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL app_Init(
	LPSSTATE		pState
){
	PSAPPINFO		paInfo;

	// 
	pState->papInfo = (PSAPPINFO)GlobalAlloc(GPTR,sizeof(SAPPINFO));
	if (pState->papInfo == NULL) {
		return(FALSE);
	}
	paInfo = pState->papInfo;

	return(TRUE);
}

/******************************************************************************
|	I
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|Return	|BOOL				ߒl
|Memo	|-
******************************************************************************/
BOOL app_Exit(
	PSSTATE			pState
){
	PSAPPINFO		paInfo;

	// 擾
	if (pState->papInfo == NULL) {
		return(FALSE);
	}
	paInfo = pState->papInfo;
	GlobalFree(pState->papInfo);
	pState->papInfo = NULL;

	return(TRUE);
}

/******************************************************************************
|	`
|-------+-------------------+--------------------------------------------------
|Entry	|pState				Ǘ
|		|hDC				޲÷
|		|prcRc				``
|Return	|BOOL				ߒl
|Memo	|pState->iFrame𗘗p
******************************************************************************/
BOOL app_Paint(
	PSSTATE			pState,
	HDC				hDC,
	LPRECT			prcRc
){
	PSAPPINFO		paInfo;
	RECT			rcRc;
	int				iWidth;
	int				iHeight;
	DWORD			dwFrame;

	// 
	paInfo = pState->papInfo;
	if (paInfo == NULL) {
		return(FALSE);
	}
	if (pState->bPreview == TRUE) {				// vr[
	}
	iWidth = GetRectWidth(prcRc);				// `̈̉
	iHeight = GetRectHeight(prcRc);				// `̈̏c
	dwFrame = pState->dwFrame;					// NẴt[

// []
// ɉʂ͍œhׂĂ܂B
// hDC̓[NpobNobt@[łB͂܂B
// hDCɑ΂ĕ`s΂̂܂܉ʂ֔f܂B
{
	// TvR[hł
	DWORD			dwBG[] = {
		UTIL_GD_LEFT,UTIL_GD_RIGHT,UTIL_GD_TOP,UTIL_GD_BOTTOM};
	TCHAR			szBuf[MAX_STR];
	HICON			hIcon;
	float			fRag;
	POINT			ptPos;
	int				lp;

	// Background
	rcRc = *prcRc;
	util_DrawGradation(hDC,&rcRc,
		RGB((dwFrame * 8 + 32) & 0xff,
			(dwFrame * 16 + 32) & 0xff,(dwFrame * 32 + 32) & 0xff),
		RGB_BLACK,dwBG[rand() & 3]);
	// Draw
	rcRc = *prcRc;
	util_DrawText(hDC,"[WSCRSV] simple screen server skelton project..",
		RGB_LTRED,RGB_WHITE,&rcRc,UTIL_DT_CENTER | UTIL_DT_SHADOW);
	OffsetRect(&rcRc,0,32);
	util_DrawText(hDC,"Copyright(C)1997-1999,2000 Scope,Kazuhiko Watanabe",
		RGB_LTBLUE,RGB_WHITE,&rcRc,UTIL_DT_CENTER | UTIL_DT_SHADOW);
	OffsetRect(&rcRc,0,32);
	util_DrawText(hDC,"http://ww5.et.tiki.ne.jp/~scope/",
		RGB_LTGREEN,RGB_WHITE,&rcRc,UTIL_DT_CENTER | UTIL_DT_SHADOW);
	rcRc = *prcRc;
	rcRc.bottom = rcRc.top + 32;
	wsprintf(szBuf,"Frame counter:%d",dwFrame);
	util_DrawText(hDC,szBuf,
		RGB_YELLOW,RGB_RED,&rcRc,UTIL_DT_CENTER | UTIL_DT_BORDER);
	// Icon
	for(lp = 0;lp < 32;lp++) {
		fRag = (float)3.1415926535 / (float)180;
		fRag = fRag * (float)((dwFrame * 8 + lp * 11) % 360);
		ptPos.x = (long)(cos(fRag) * (double)(iWidth / 2 - 32));
		ptPos.y = (long)(sin(fRag) * (double)(iHeight / 2 - 32));
		ptPos.x += (iWidth / 2) - 16;
		ptPos.y += (iHeight / 2);
		hIcon = LoadIcon(pState->hInst,MAKEINTRESOURCE(IDI_ICON));
		DrawIcon(hDC,ptPos.x,ptPos.y,hIcon);
	}
}
//@[܂]
	
	return(TRUE);
}

